/**
 * 
 */
package com.perfectech.tis;

import java.io.IOException;
import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.util.Log;

/**
 * @author jcairns
 *
 */
public class DBParameters {

	public String readParameter(String sParamName, Context oContext, String sDBName, int iVersionVal) {
		String sRtnVal = "";
	
		try
		{
	    	TISDBHelper oDB = new TISDBHelper(oContext,sDBName,null,iVersionVal);
	    	try {
	        	oDB.createDataBase();
	    	} catch (IOException ioe) {
	    		throw new Error("Unable to create database");
	    	}
	    	
			oDB.openDataBase();

			String sSQL = "select Value from Parameters where Name = '";
	    	sSQL += sParamName + "'";
	    	
	    	ArrayList<ArrayList<String>> sStringList = oDB.selectRecordsFromDBList(sSQL, null);

			oDB.close();
			
			for (ArrayList<String> sValue : sStringList)
			{
				sRtnVal = sValue.get(0);
			}
			
		} catch (Exception ex) {
			Log.d("DBParameter.readParameter(): ", ex.toString());
		}
		
		return sRtnVal;
	}
	
	public void updateParameter(String sParamName, String sParamValue, Context oContext, String sDBName, int iVersionVal) {
		try
		{
	    	TISDBHelper oDB = new TISDBHelper(oContext,sDBName,null,iVersionVal);
	    	try {
	        	oDB.createDataBase();
	    	} catch (IOException ioe) {
	    		throw new Error("Unable to create database");
	    	}
	    	
			oDB.openDataBase();
			ContentValues oValues = new ContentValues();
			oValues.put("Value", sParamValue );
			oDB.updateRecordsInDB("Parameters", "Name = '" + sParamName +"'", oValues);
			oDB.close();
		} catch (Exception ex) {
		   Log.d("Error:", ex.toString());
		}
	}
	
	public void insertParameter(String sParamName, String sParamValue, Context oContext, String sDBName, int iVersionVal) {
		try
		{
	    	TISDBHelper oDB = new TISDBHelper(oContext,sDBName,null,iVersionVal);
	    	try {
	        	oDB.createDataBase();
	    	} catch (IOException ioe) {
	    		throw new Error("Unable to create database");
	    	}
	    	
			oDB.openDataBase();
			ContentValues oValues = new ContentValues();
			oValues.put("Name", sParamName);
			oValues.put("Value", sParamValue);
			oDB.insertRecordsInDB("Parameters", null, oValues);
			oDB.close();
		} catch (Exception ex) {
			
		}
		
	}

	public void deleteParameter(String sParamName, Context oContext, String sDBName, int iVersionVal) {
		try
		{
	    	TISDBHelper oDB = new TISDBHelper(oContext,sDBName,null,iVersionVal);
	    	try {
	        	oDB.createDataBase();
	    	} catch (IOException ioe) {
	    		throw new Error("Unable to create database");
	    	}
	    	
			oDB.openDataBase();
			String sWhereClause = "Name='" + sParamName + "' ";
			oDB.deleteRecordInDB("Parameters", sWhereClause);
			oDB.close();
		} catch (Exception ex) {
			
		}
		
	}
}
